const canv = document.getElementById('fullCanvas');
let c, center;
function getBounds(){
  canv.width = parseFloat(getComputedStyle(canv).width); 
  canv.height =  parseFloat(getComputedStyle(canv).height);
  c = canv.getContext('2d');
  center = {x: canv.width/2, y: canv.height/2};
  if (document.Update) document.Update(0);
}
getBounds();
window.addEventListener('resize', getBounds);
//End of setup

let n1 = parseInt(document.getElementById('n1').value);
let theta1 = parseFloat(document.getElementById('theta1').value);
let n2 = parseInt(document.getElementById('n2').value);
let theta2 = parseFloat(document.getElementById('theta2').value);

import {rad2deg, deg2rad, clamp} from '../modules/utility.js';

function Update(index){
  n1 = document.getElementById('n1').value = Math.max(parseFloat(document.getElementById('n1').value), 1);
  theta1 = document.getElementById('theta1').value = clamp(parseFloat(document.getElementById('theta1').value), 0, 90);
  n2 = document.getElementById('n2').value = Math.max(parseFloat(document.getElementById('n2').value), 1);
  theta2 = document.getElementById('theta2').value = clamp(parseFloat(document.getElementById('theta2').value), 0, 90);
  switch(index){
    default:
    case 0:
    case 1:
    case 2:
      theta2 = rad2deg(Math.asin(Math.sin(deg2rad(theta1)) * n1/n2));
      if (isNaN(theta2)) theta2=90;
      document.getElementById('theta2').value = theta2.toFixed(3);
      break;
    case 3:
      n2 = n1 * (Math.sin(deg2rad(theta1)) / Math.sin(deg2rad(theta2))); 
      document.getElementById('n2').value = n2.toFixed(3);
      break;
  }
  console.log(`n1=${n1} - T1=${theta1}, n2=${n2} - T2=${theta2}, p1:${n1*Math.sin(theta1)} - p2:${n2*Math.sin(theta2)}`);
  
  let width = canv.width, height = canv.height, scaleFactor = width*height;
  //Map
  c.clearRect(0, 0, width, height);
  
  c.strokeStyle = 'black';
  c.lineWidth = 1.2;
  c.beginPath();
  c.moveTo(0, height/2);
  c.lineTo(width, height/2);
  c.stroke();
  
  c.lineWidth = 0.3;
  c.beginPath();
  c.moveTo(width/2, height);
  c.lineTo(width/2, 0);
  c.stroke();
  
  c.lineWidth=1;
  c.strokeStyle = 'green';
  c.beginPath();
  c.moveTo(width/2 - (Math.sin(deg2rad(theta1))) * scaleFactor, height/2 - (Math.cos(deg2rad(theta1))*scaleFactor));
  c.lineTo(width/2, height/2);
  c.stroke();
  
  //Letras 1
  c.lineWidth=0.5;
  c.strokeStyle = 'black';
  c.beginPath();
  c.strokeText(`n1=${n1}`, width * 0.01, height/2.2);
  if (theta1 <= 45){
    c.strokeText(`\u03B8\u1D62=${theta1}`, width/2.3 - Math.sin(deg2rad(theta1))*30, height/2.2);
  } else {
    c.strokeText(`\u03B8\u1D62=${theta1}`, width/2.4, height/2.5 - Math.cos(deg2rad(theta1))*30);
  }
  
  c.lineWidth=0.7;
  c.strokeStyle = 'mediumseagreen';
  c.beginPath();
  c.arc(width/2, height/2, height/10, -Math.PI/2 - deg2rad(theta1), -Math.PI/2, false);
  c.stroke();
  
  //Letras 2
  c.lineWidth=0.5;
  c.strokeStyle = 'black';
  c.beginPath();
  c.strokeText(`n1=${n2}`, width * 0.01, height/1.8);
  if (theta2 <= 45){
    c.strokeText(`\u03B8\u1D62=${parseFloat(theta2.toFixed(2))}`, width/1.9 + Math.sin(deg2rad(theta2))*30, height/1.8);
  } else {
    c.strokeText(`\u03B8\u1D62=${parseFloat(theta2.toFixed(2))}`, width/1.95, height/1.6 + Math.cos(deg2rad(theta2))*30);
  }
  
  c.lineWidth=0.7;
  c.strokeStyle = 'dodgerblue';
  c.beginPath();
  c.arc(width/2, height/2, height/10, Math.PI/2 - deg2rad(theta2), Math.PI/2, false);
  c.stroke();
  
  //c.lineWidth=1;
  c.strokeStyle = 'blue';
  c.beginPath();
  c.moveTo(width/2 + (Math.sin(deg2rad(theta2))) * scaleFactor, height/2 + (Math.cos(deg2rad(theta2))*scaleFactor));
  c.lineTo(width/2, height/2);
  c.stroke();
}
document.Update = Update;
Update(0);