import { Vector2 } from "../modules/vectors.js";
import { PI2 } from "../modules/utility.js";

export class Circle {
  constructor(_x, _y, _size, _style, _velocity) {
    this.x = _x;
    this.y = _y;
    this.size = _size;
    this.style = _style || "black";

    if (_velocity) this.velocity = _velocity;
    else this.velocity = Vector2.zero;
  }

  draw(c) {
    c.fillStyle = this.style;
    c.beginPath();
    c.arc(this.x, this.y, this.size, 0, PI2, false);
    c.fill();
  }

  get position() {
    return new Vector2(this.x, this.y);
  }
  set position(nPosition) {
    this.x = nPosition.x;
    this.y = nPosition.y;
  }
  get velocity() {
    return new Vector2(this.vx, this.vy);
  }
  set velocity(nVel) {
    this.vx = nVel.x;
    this.vy = nVel.y;
  }
}
