/* SETUP
const canv = document.getElementById('fullCanvas');
let c;
function getBounds(){
  canv.width = parseFloat(getComputedStyle(canv).width); 
  canv.height =  parseFloat(getComputedStyle(canv).height);
  c = canv.getContext('2d');
}
getBounds();
window.addEventListener('resize', getBounds);
*/
export class Time {
  constructor(){
    this.t0 = this.t1 = Date.now();
    this.totalTime = 0;
  }
  
  update(){
    this.t1 = this.t0;
    this.t0 = Date.now();
    
    this.totalTime += this.deltaTime;
  }
  
  get deltaTime(){
    return this.t1 - this.t0;
  }
}

export function getRandomColor(brightness){
  brightness = (brightness || 1) * 255;
  return `rgb(${Math.random() * brightness}, ${Math.random() * brightness}, ${Math.random() * brightness})`;
}

//MATH
export const PI2 = Math.PI * 2;
export function rad2deg(num) {
  return num*180/Math.PI;
}
export function deg2rad(num) {
  return num*Math.PI/180;
}
export function clamp(num, min, max){
  return Math.min(Math.max(min, num), max);
}

export const GravityConst = 6.6743e-11; // (N * m2) / Kg2

