export class Vector2{
  constructor(_x, _y){
    this.x = _x;
    this.y = _y;
  }
  
  static get zero() { return new Vector2(0, 0);}
  static get up() { return new Vector2(0, 1);}
  static get down() { return new Vector2(0, -1);}
  static get left() { return new Vector2(-1, 0);}
  static get right() { return new Vector2(1, 0);}
  
  static get random() { return new Vector2(Math.random()-0.5, Math.random()-0.5).normalized;}
  
  set position(u){
    this.x = u.x;
    this.y = u.y;
  }
  
  distance(u){
    return this.substract(u).module;
  }
  
  sum(u){
    return new Vector2(this.x + u.x, this.y + u.y);
  }
  rSum(u){
    this.x += u.x; 
    this.y += u.y;
  }
  
  substract(u){
    return new Vector2(this.x - u.x, this.y - u.y);
  }
  rSubstract(u){
    this.x -= u.x; 
    this.y -= u.y;
  }
  
  get module(){
    return Math.sqrt(this.x**2 + this.y**2);
  }
  get normalized(){
    return this.divide(this.module);
  }
  normalize(){
    this.rdivide(this.module);
  }
  
  multiply(u){
    switch(typeof u){
      default:
        console.log('No valid type of number to do the operation');
        break;
      case "number":
        return new Vector2(this.x * u, this.y * u);
        break;
      case "class":
        //MAKE CONVERSION WHEN DEVELOP
        //if (u instanceof Vector3)
        
        if (u instanceof Vector2){
          console.log('No operation with vector2 defined yet');
        }
        break;
    }
  }
  rMultiply(u){
    this.position = this.multiply(u);
  }
  
  divide(u){
    switch(typeof u){
      default:
        console.log('No valid type of number to do the operation');
        break;
      case "number":
        return new Vector2(this.x / u, this.y / u);
        break;
      case "class":
        //MAKE CONVERSION WHEN DEVELOP
        //if (u instanceof Vector3)
        
        if (u instanceof Vector2){
          console.log('No operation with vector2 defined yet');
        }
        break;
    }
  }
  rDivide(u){
    this.position = this.divide(u);
  }
}
